FYP_WICC/accounts/urls.py
from django.urls import path 

from accounts.views import dashboard_views, views
 

app_name = 'accounts'

urlpatterns = [ 

    path('profile/', views.ProfileDetailView.as_view(), name='profile'),
    path('signup/', views.SignupView.as_view(), name='signup'),
    path('otp-verify/', views.OTPverify.as_view(), name='otp-verify'),
    path('login/', views.LoginFormView.as_view(), name='login'),
    path('logout/', views.UserLogoutView.as_view(), name='logout'),
    path('forget-password/', views.ForgotPasswordView.as_view(), name='forget-password' ),
    path('reset-password/<token>/', views.ResetPasswordView.as_view(), name='reset-password'),
    path('update-profile/<int:pk>/', views.UserUpdateView.as_view(), name='update-profile'),

    #payment
    path('verify-payment/', views.VerifyPaymentView.as_view(), name='verify-payment'),

    path('my-certificate/', views.MyCertificateView.as_view(), name='my_certificate'),
    path('add-owner-certificate/', views.AddCertificateView.as_view(), name='add_owner_certificate'),

    path('my-reservations/', views.MyReservationsView.as_view(), name='reservations'),
    path('<int:pk>/my-reservation-details/', views.ReservationDetailView.as_view(), name='reservation_details'),
    path('<int:pk>/cancel-reservation/', views.CancelReservationView.as_view(), name='reservation_cancel'),
    
    path('myhotel/my-hotel-detail/', views.MyHotelDetailView.as_view(), name='my_hotel_detail'),
    path('myhotel/reservation-dashboard/', views.HotelReservationDashboardView.as_view(), name='myhotel_reservation'),
    path('myhotel/filter-reservations/', views.ReservationFilterByOwnerView.as_view(), name='myhotel_filter_reservations'),
    path('myhotel/<int:pk>/customer-reservation-detail/', views.CustomerReservationDetailView.as_view(), name='customer_reservation_detail'),
    path('myhotel/<int:pk>/update-customer-reservation/', views.UpdateCustomerReservationView.as_view(), name='update_customer_reservation'),

    path('dashboard/', dashboard_views.DashboardView.as_view(), name='dashboard'),
    path('dashboard/group-filter/', dashboard_views.GroupUserFilterView.as_view(), name='group_filter'),
    path('dashboard/all-reservations/', dashboard_views.AllReservationView.as_view(), name='all_reservations' ),
    path('dashboard/reservation-hotel-filter/', dashboard_views.ReservationHotelFilterView.as_view(), name='reservation_hotel_filter'),
    path('dashboard/all-hotels/', dashboard_views.AllHotelsView.as_view(), name='all_hotels'),
    path('dashboard/<int:pk>/user-detail/', dashboard_views.DashboardUserDetail.as_view(), name='dashboard_user_detail'),
    path('dashboard/<int:pk>/verify-account/', dashboard_views.VerifyOwnerAccountView.as_view(), name='verify_account'),  

]

FYP_WICC/hbmsProject/urls.py
from django.contrib import admin
from django.urls import path, include 
from django.conf import settings 
from django.conf.urls.static import static

urlpatterns = [
    path('admin/', admin.site.urls),

    path('', include('hotels.urls', namespace='hotels')),
    path('accounts/', include('accounts.urls', namespace='accounts')),
    path('stats/', include('stats.urls', namespace='stats')),

    path('api/hotels/', include('hotels.api.urls', namespace='hotels-api')),
    path('api/accounts/', include('accounts.api.urls', namespace='accounts-api')),
    
    
    
] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT) + static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)

# if settings.DEBUG:
#     import debug_toolbar
#     urlpatterns +=  path('__debug__/', include('debug_toolbar.urls')), 
 

FYP_WICC/hotels/api/urls.py
from django.urls import path, include 

from rest_framework.routers import DefaultRouter
from rest_framework.authtoken import views as token_views

from hotels.api.views import hotel_views, reservation_views

app_name = 'hotels_api'

router = DefaultRouter()
router.register('', hotel_views.HotelViewSet,basename='hotels' )

urlpatterns = [ 
    path('', include(router.urls)),
    path('comments/add/', hotel_views.CommentModelView.as_view(), name='comment'),
    # path('token/get-my-token/', token_views.obtain_auth_token ),

    path('owner/my-hotel/', hotel_views.MyHotelView.as_view()),
    path('reserve/reservations/', reservation_views.HotelReservationView.as_view()),
    path('reserve/reservations/all/', reservation_views.AllHotelReservationsListAPIView.as_view()), 
    path('reserve/reservations/<int:pk>/', reservation_views.HotelReservationView.as_view()),
    path('reserve/reservations/cancel-reservation/<int:pk>/', reservation_views.CancelReservationView.as_view() ),

    
]

FYP_WICC/hotels/urls.py
from django.urls import path 

from . import views 

app_name = 'hotels'

urlpatterns = [ 
    path('', views.HotelListView.as_view(), name='hotel_list'),
    path('sort-hotel/', views.HotelSortView.as_view(), name='hotel_sort' ),
    # path('address/', views.HotelAddressSelectView.as_view(), name='hotel_address' ), 
    path('search/', views.HotelSearchView.as_view(), name='hotel_search'),

    path('add-hotel/', views.HotelCreateView.as_view(), name='hotel_create'),
    path('<int:pk>/detail/', views.HotelDetailView.as_view(), name='hotel_detail'),
    path('<int:pk>/update/', views.HotelUpdateView.as_view(), name='hotel_update'),
    path('<int:pk>/delete/', views.HotelDeleteView.as_view(), name='hotel_delete'),
    path('<int:pk>/comment/', views.HotelCommentView.as_view(), name='hotel_comment'),
    
    path('<int:pk>/reserve/', views.ReserveHotelView.as_view(), name='hotel_reserve'),
    

]

FYP_WICC/stats/urls.py
from django.urls import path 

from stats import views 

app_name = 'stats'

urlpatterns = [ 
    path('', views.HotelOwnerReportView.as_view(), name='report'),
    path('dashboard/reservation-report/', views.DashboardReservationReportView.as_view(), name='dashboard_reservation_report'),

    path('report/one-day-reservation/', views.pdfReportReservation, name='one_day_reservation_report'),
    path('report/reservation-date-pdf/', views.PdfReportReservationView2.as_view(), name='reservation_date_pdf'),
    

]

FYP_WICC/hotels/models.py
 
from django.db import models
from django.conf import settings
from django.urls import reverse 

# from accounts.models import CustomUser

# Create your models here.

class Hotel(models.Model):
    owner = models.OneToOneField(settings.AUTH_USER_MODEL, primary_key=True, on_delete=models.CASCADE)
    name = models.CharField(max_length=100, unique=True)
    address = models.CharField(max_length=100)
    phone = models.CharField(max_length=10, null=True)
    email = models.CharField(max_length=200, null=True, unique=True)
    total_rooms = models.PositiveIntegerField(default=0)
    available_rooms = models.PositiveIntegerField(default=0)
    room_price = models.PositiveIntegerField(default=0)
    rate = models.PositiveIntegerField(default = 0)
    established = models.DateField()
    description = models.TextField(null=True, blank=True)
    # map_link = models.URLField(max_length=200, null=True, blank=True)
    map_link = models.TextField(null=True, blank=True)

    def __str__(self):
        return f"{self.name}"

    def get_absolute_url(self):  
        return reverse('hotels:hotel_detail', kwargs={'pk': self.pk})


class ImageModel(models.Model):
    hotel = models.ForeignKey(Hotel, on_delete=models.CASCADE, related_name='hotel_images')
    image = models.ImageField(upload_to='hotel', null=True, blank=True)

PAYMENT_METHOD = (
    ('online_pay', 'Online Pay'),
    ('offline_pay', 'Offline Pay')
)

"""RESERVATION_STATUS = (
    ('pending', 'pending'),
    ('completed', 'completed')
)"""

RESERVATION_STATUS = (
    ('reserved', 'reserved'),
    ('checked_in', 'checked_in'),
    ('checked_out', 'checked_out')
)

class Reservation(models.Model):
    no_of_rooms = models.PositiveIntegerField(default=0)
    reserved_date = models.DateTimeField(auto_now_add = True)
    checkin_date = models.DateTimeField(blank=True, null=True)
    checkout_date = models.DateTimeField(blank=True, null=True)
    amount = models.PositiveIntegerField(default=0)
    paid = models.BooleanField(default=False)
    payment_method = models.CharField(max_length=15, choices=PAYMENT_METHOD, default='offline_pay')
    customer = models.ForeignKey(settings.AUTH_USER_MODEL, on_delete=models.SET_NULL, null=True, related_name='customer_reservations')
    hotel = models.ForeignKey(Hotel, on_delete=models.CASCADE, related_name='hotel_reservations')
    phone = models.CharField(max_length=10)   
    checkin_status =  models.CharField(max_length=15, choices=RESERVATION_STATUS, default="reserved")

    @property
    def get_CustomerName(self):
        return self.customer.username 

    @property
    def get_HotelName(self):
        return self.hotel.name

class Comment(models.Model):
    content = models.CharField(max_length=250, blank=False, null=False)
    customer = models.ForeignKey(settings.AUTH_USER_MODEL, on_delete=models.CASCADE)
    hotel = models.ForeignKey(Hotel, on_delete=models.CASCADE, related_name='hotel_comments')
    date_time = models.DateTimeField(auto_now_add=True)

FYP_WICC/hotels/forms.py
from django import forms 
from django.contrib.auth import get_user_model

from .models import Hotel, Reservation, Comment
 
class HotelAddForm(forms.ModelForm): 
    image = forms.ImageField(widget= forms.FileInput(attrs={'multiple':True,"accept":"image/*", "required":False}))
    
    class Meta:
        model = Hotel 
        fields = ["name", "address","email", "phone", "total_rooms", "room_price", "established", "description", "map_link"]

        help_texts = {
            'map_link': 'copy the embeded link code from google map/ * (optional)',
        }
        widgets = {
            'description': forms.Textarea(attrs={'rows':5}),
            'map_link': forms.Textarea(attrs={'rows':8}),
            'established': forms.NumberInput(attrs={'type': 'date'}),
        }

    def __init__(self, *args, **kwargs):
        super().__init__(*args, **kwargs)
        for field in self.fields: 
            self.fields[field].widget.attrs.update({'class': 'form-control'})

class ReservationForm(forms.ModelForm):

    class Meta:
        model = Reservation
        fields = ['no_of_rooms', 'phone']
        labels = {
            'phone': 'Your mobile no.'
        }

    def __init__(self, *args, **kwargs):
        super().__init__(*args, **kwargs)
        for field in self.fields:
            self.fields[field].widget.attrs.update({'class': 'form-control'})

    def clean(self):
        cleaned_data = super().clean()   
        phn = cleaned_data.get('phone')
        no_of_rooms = cleaned_data.get('no_of_rooms')
        if no_of_rooms == 0:
            self.add_error('no_of_rooms', 'No. of rooms should be greater than zero.')
        if phn:
            import re
            if not re.match(r'^98[0-9]{8}$', phn):
                # raise ValidationError('Phone no. must be numeric of length 10.')
                self.add_error('phone', 'Phone no. must be numeric of length 10 and start with 98.')
        return cleaned_data

class ReservationUpdateForm(forms.ModelForm): 
    
    class Meta:
        model = Reservation
        fields = ['no_of_rooms', 'payment_method', 'amount', 'paid', 'checkin_status']
        widgets = {
            'paid': forms.CheckboxInput
        }

    def __init__(self, *args, **kwargs):
        super().__init__(*args, **kwargs)
        for field in self.fields:
            if not(field=='paid'):
                self.fields[field].widget.attrs.update({'class': 'form-control'})
            else:
                self.fields[field].widget.attrs.update({'class': 'form-check-input'})

class CommentForm(forms.ModelForm):
    
    class Meta:
        model = Comment
        fields = ('content',)

FYP_WICC/hotels/api/views/hotel_views.py
from django.contrib.auth import get_user_model
from django.db import transaction

from rest_framework.response import Response 
from rest_framework.views import APIView
from rest_framework import viewsets 
from rest_framework.permissions import IsAuthenticated
from rest_framework import status
from rest_framework.parsers import JSONParser, MultiPartParser, FormParser

from hotels.models import Hotel, ImageModel, Reservation
from ..serializer import HotelSerializer, HotelUpdateSerializer, HotelListSerializer, HotelRetrieveSerializer, CommentSerializer
from ..permissions import IsAdminOwnerCustomerFilter

CustomUser = get_user_model()

class HotelViewSet(viewsets.ModelViewSet):
    serializer_class = HotelSerializer
    model = Hotel 
    queryset = Hotel.objects.prefetch_related('hotel_images').all().order_by('-owner__id')
    # permission_classes = [ IsAuthenticated, IsAdminOwnerCustomerFilter]
    permission_classes = [IsAdminOwnerCustomerFilter,]
    parser_classes = [MultiPartParser, JSONParser, FormParser]

    def get_serializer_class(self): 
        if self.action == "update": 
            return HotelUpdateSerializer
        elif self.action=="list":
            return HotelListSerializer
        elif self.action == "retrieve":
            return HotelRetrieveSerializer
        return self.serializer_class

    
    # def list(self, request, *args, **kwargs):
    #     queryset = Hotel.objects.prefetch_related('hotel_images').all().order_by('-owner__id')

    #     serializer = GetHotelSerializer(queryset, many=True)
    #     print(serializer.data)
    #     return Response(serializer.data)

    def create(self, request, *args, **kwargs):  
        # print(request.data)
        # print(request.FILES)
        images =  None
        if request.data.get('image'):
            images = request.FILES.getlist('image')  
            request.data.pop('image')
        serializer = self.get_serializer(data=request.data) 

        if not self.request.user.verified:
            return Response({"message": "You're not a verified hotel owner."}, status=status.HTTP_401_UNAUTHORIZED)
        elif Hotel.objects.filter(owner=self.request.user).exists():
            return Response({"message": "A user can have only one hotel."}, status=403)
        
        if serializer.is_valid():
            # hotel_obj = Hotel.objects.create(
            #     owner= request.user,
            #     name = serializer.data.get('name'),
            #     address = serializer.data.get('address'),
            #     email = serializer.data.get('email'),
            #     phone = serializer.data.get('phone'),
            #     total_rooms = serializer.data.get('total_rooms'),
            #     established = serializer.data.get('established'),
            #     description = serializer.data.get('description'),
            # )  
            
            try:
                with transaction.atomic(): 
                    serializer.save( owner = request.user ) 
                    hotel_obj = request.user.hotel 
                    if images:  
                        for img in images:  
                            ImageModel.objects.create(hotel=hotel_obj, image=img)
            except Exception as e: 
                return Response({'err': e.__str__()}, status=status.HTTP_400_BAD_REQUEST)
            return Response({"message": "Hotel objezct created successfully.", "hotel_obj": serializer.data}, status=200)
            
        return Response({"message":"Error occured", "errors": serializer.errors})


    def update(self, request, *args, **kwargs):
        instance = self.get_object()
        if instance.owner == self.request.user:
            serializer = self.get_serializer(instance, data=self.request.data )
            
            if serializer.is_valid():
                serializer.save() 
                return Response({"message":"Update success", "updated_data": serializer.data}, status=status.HTTP_200_OK)
            
            return Response({"error": serializer.errors}, status=status.HTTP_400_BAD_REQUEST)
        else:
            return Response({"message": "Sorry, you are not authorized to update others hotel details."}, status=status.HTTP_401_UNAUTHORIZED)

    def destroy(self, request, *args, **kwargs):

        if self.request.user.groups.filter(name__in = ['admin-gang']).exists():
            obj = self.get_object()
            obj.delete()
            return Response({"message":"Deletion success."}, status=status.HTTP_200_OK)
        else: 
            return Response({"message":"Your're not allowed to delete hotel"}, status=status.HTTP_403_FORBIDDEN)

    
class MyHotelView(APIView):
    queryset = Hotel.objects.all()
    serializer_class = HotelRetrieveSerializer
    permission_classes = [IsAuthenticated,]
    
    def get(self, request, *args, **kwargs): 
        if request.user.groups.filter(name__in=['hotelOwner-gang']).exists() and request.user.verified:
            has_hotel = False
            try:
                hotel = Hotel.objects.get(owner = request.user)
                has_hotel = True 
            except Exception as e:
                return Response({'error': e.__str__()})
            serialized = self.serializer_class(hotel)
            return Response(serialized.data, status=status.HTTP_200_OK)

        return Response("Only verified hotelOwner member can retrieve their hotel infomations.", status=status.HTTP_401_UNAUTHORIZED)

""" Comment part """

class CommentModelView( APIView):
    permission_classes = [IsAuthenticated,]
    
    def post(self, request,format=None): 
        # serialized = CommentSerializer(data=request.data, context={'request': request})
        serialized = CommentSerializer(data=request.data )
        if serialized.is_valid():
            serialized.save(customer= request.user)
            return Response({'message': 'comment saved successfully', 'comment': serialized.data}, status=status.HTTP_201_CREATED)
        
        return Response({'errors': serialized.errors}, status=status.HTTP_400_BAD_REQUEST)

FYP_WICC/templates/hotels/add_hotel.html
{% extends 'base.html' %}

{% block title %}Add Hotel{% endblock %}

{% block content %}

<div class="row mt-3 mb-3">

    <div class="col-5 mx-auto">
        <p style="font-family: 'Brush Script MT', cursive; font-size:35px;" class="my-3">Add Hotel Details</p>
        <form method="post" novalidate enctype="multipart/form-data"> 

            {% if form.non_field_errors %}
                {% for err in form.non_field_errors %}
                    <p style="color:red;">{{ err }}</p>
                {% endfor %}
            {% endif %}

            {% csrf_token %}
            {% for field in form %}
               <p> {{ field.label_tag }} {{ field}} <span class="text-muted">{{field.help_text}}</span><span style="color:red;">{{ field.errors|striptags }}</span></p>
            {% endfor %}
            <input type="submit" value="Add" class="btn btn-success px-4">
            <a class="btn btn-secondary mx-2" href="{% url 'accounts:profile' %}">Cancel</a>
        </form>
    </div>

</div>

{% endblock %}

FYP_WICC/templates/hotels/detail.html
{% extends 'base.html'  %} 
{% load static %}

{% block title %}Details{% endblock title %}

{% block content %} 

<style type="text/css">
	img{
		height: 550px;
		width: 550px;
	}
</style> 

<div class="container mt-1 mb-4" style="width: 72%;">
	{% if messages %}
		{% for message in messages %}
			<p class="alert alert-{% if message.tags %}{{message.tags}}{%else%}info{% endif %}">{{ message }}</p>
		{% endfor %}
	{% endif %}
	<div class="row">

		{% if hotel.hotel_images.count %}
			<div id="carouselExampleIndicators" class="carousel slide" data-ride="carousel">
				<div class="carousel-inner">
					{% for img in hotel.hotel_images.all %} 
					<div class="carousel-item {% if forloop.first %} active {% endif %}">
						<img class="d-block w-100" src="{{img.image.url}}" style="width: 100%; height: 700px;" alt="First slide">
					</div>
					{% endfor %}
				</div>

				<a class="carousel-control-prev" href="#carouselExampleIndicators" role="button" data-slide="prev">
				  <span class="carousel-control-prev-icon" aria-hidden="true"></span>
				  <span class="sr-only"></span>
				</a>
				<a class="carousel-control-next" href="#carouselExampleIndicators" role="button" data-slide="next">
				  <span class="carousel-control-next-icon" aria-hidden="true"></span>
				  <span class="sr-only"></span>
				</a>
			</div>
			{% else %}
				<!-- <p style="text-align: center;">No Image</p> -->
                    <img src="{% static 'default_hotel.jpeg' %}" style="height: 600px; width:100%;" class="card-img-top" alt="...">
			{% endif %}

	</div>

	<div class="row mt-3">  
		<div class="col-lg-5 border" style="border-radius: 20px;">
			<h3 class="mt-3" style="color:rgb(236, 0, 0); text-align: center;" >{{hotel.name}}</h3>
			<hr>
			<div class="container-fluid">
				<div class='row'>
					<div class='col-lg-7 border'>
                        <p><b>Address:</b> {{hotel.address}}</p>
						<p><b>Phone:</b> {{hotel.phone}}</p>
						<p><b>Email:</b> {{hotel.email}}</p>
                        <p><b>Hotel Owner:</b> {{hotel.owner}}</p>
						<p><b>Avg. Rating:</b> {{hotel.rate}}</p>
					</div>

					<div class="col-lg-5 border">   
                        <p><b>Per Room Price:</b> NPR{{hotel.room_price}}</p>
                        <p><b>Total Rooms:</b> {{hotel.total_rooms}}</p>
                        <p style="color: {% if hotel.available_rooms == 0 %}red{% else %}black{% endif %};" ><b>Available Rooms:</b> {{hotel.available_rooms}}</p> 
                        <p><b>Estd. :</b> {{hotel.established}}</p>
							
							{% if request.user.is_authenticated %}
								{% if hotel.owner == request.user %}
										<p>
											<a href="{% url 'hotels:hotel_update' hotel.owner.id %}" class="btn btn-info" style="width: 100%;">Update Details</a>
										</p>
								{% endif %}
								<p>
									<a href="{% url 'hotels:hotel_reserve' hotel.owner.id %}" id="bookId"  class="btn btn-success" style="width: 100%;">Book</a>
								</p>
							{% endif %}
					</div>
				</div>
			</div>
			<hr>
			<p><h5>Description:</h5>{{hotel.description}}</p>
			<hr>    
		</div>

		<div class="col-lg-7 border" style="border-radius: 20px;" >
			<div class="mt-2 mb-3 overflow-auto">
				<p style="font-family: 'Brush Script MT', cursive; font-size:26px; color:rgb(24, 156, 218);text-align: center;" >Google map location</p>
				<div  style="text-align:center;">{{hotel.map_link|safe}}</div>
			</div>				
		</div> 
	</div>  
	
	<!-- <iframe src="https://www.google.com/maps/embed?pb=!1m14!1m8!1m3!1d18124.933341512497!2d85.28847587659688!3d27.701880068648517!3m2!1i1024!2i768!4f13.1!3m3!1m2!1s0x0%3A0x44edd8fc9a17af63!2sThe%20Soaltee%20Kathmandu!5e0!3m2!1sen!2snp!4v1645784928491!5m2!1sen!2snp" width="600" height="450" style="border:0;" allowfullscreen="" loading="lazy"></iframe> -->  
 
	<h3>Comments</h3>
	{% if request.user.is_authenticated %}
		<form method="POST" id="commentForm">
			{% csrf_token %}

			<div class="mb-3"> 
				<textarea  class="form-control" id="comment" rows="5" name="content" placeholder="Comment..."></textarea>
				<div id="comment" class="form-text"></div>
			</div>
			<input type="submit" value="Comment" class="btn btn-success mb-3">
		</form>
	{% endif %}
	<div id="commentsId"> 
			{% for comment in comment_list %}
				<p><b>{{ comment.customer.username }}</b> on <span class="text-muted">{{ comment.date_time }}</span> <br>{{ comment.content }}</p>
			{% endfor %}   
	</div>	
</div>  


<div class="modal fade" id="bookModal" tabindex="-1">
	<div class="modal-dialog">
	  <div class="modal-content">

	  </div>
	</div>
  </div>

<script>
	function closeModal(){
		$('#bookModal').modal('hide');
	}


//--------------comment part 
$('#commentForm').on('submit', function(e){
            e.preventDefault();
            let formData = new FormData(this);  
            const hotelId = "{{hotel.owner.id}}";
            const commentUrl = "{% url 'hotels:hotel_comment' 11 %}".replace(11, hotelId );

            $.ajax({
			url: commentUrl,
			method:'POST',
			data: formData,
			processData:false,
			contentType: false,
			
			success: function(resp){
				$('#commentForm')[0].reset(); 
				let instance = resp.instance; 
				let r = `<p><b>${instance.customer}</b> on<span class="text-muted">${instance.date_time}</span> <br>${instance.content}</p>`;
				// $('#commentsId').append(r);
				$('#commentsId').prepend(r);
				 
			},
			error: function(response){
				// console.log(err);
				const data = JSON.parse(response['responseText']);
				if(data.errors){
					alert(data.errors.content[0]);
				}
				else{
					alert(response);
				}
			}
		})
})


// ------------reservation part
	$('#bookId').on('click', function(e){
		e.preventDefault();
		const href = $(this).attr('href'); 

		$.get(href,function(data){
			// console.log(typeof data, data); 
			$('#bookModal .modal-content').empty().append(data);
			$('#bookModal').modal('show');  
		});
	})


	$('body').on('submit','#reservationFormId', function(e){
		e.preventDefault();
		let formData = new FormData(this);
		const hotelId = $(this).attr('data-hotelId');
		let url = "{% url 'hotels:hotel_reserve' 11 %}".replace(11, hotelId);
		
		$.ajax({
			url: url,
			method: 'POST',
			data:formData,
			processData: false,
			contentType: false,

			success: function(response){
				console.log(response, typeof response)

				$('#bookModal').modal('hide');
				alert('Hotel room is booked successfully.')
				location.reload();
			},

			error: function(response){ 
				data = JSON.parse(response['responseText']); 
				if(data['errors']){
					errors= data['errors']  
					$('small.error').remove();
					for(key in errors){ 
						if ($(`[name="${key}Error"`).length){
							$(`[name="${key}Error"]`).text(errors[key]);
						}else{ 
							$(`[name="${key}"`).parent().append(`<small name="${key}Error" class="error" style="color:red">${errors[key]}</small>`);
						}
					}  
				}else{
					alert(data['data']);
				}	
			}
		})

	})


</script>

{% endblock  %} 

FYP_WICC/templates/hotels/reserve.html
<form method="post" id="reservationFormId" data-hotelId="{{hotel_pk}}">
    <div class="modal-header"> 
        <p style="font-family: 'Brush Script MT', cursive; font-size:26px; display: inline; " >Book Hotel Room</p>
    </div>  
    {% csrf_token %}
    
    <div class="modal-body">
    {% for f in form %}
        <div class="mb-3">
            {{f.label_tag}} {{f}}
        </div>
    {% endfor %}
    </div>

    <div class="modal-footer">
        <input type="submit" class="btn btn-success" value="Save Booking">
        <button type="button" onclick="closeModal()" class="btn btn-secondary" data-bs-dismiss="modal">Cancel</button>
    </div>
</form>

FYP_WICC/templates/hotels/sortedHotelList.html
{% load static %}
{% for hotel in hotel_list %}
<div class="col-sm-3 mt-3 mb-2" >
    <div class="card card-hover" id="card1" >
        {% with h=hotel.hotel_images.all %} 
            <img src="{% if h.count > 0 %} {{h.first.image.url}} {% else %} {% static 'default_hotel.jpeg' %} {% endif %}" style="height: 280px; width:100%;" class="card-img-top" alt="...">
        {% endwith %}
        <div class="card-body">
            <a href="{% url 'hotels:hotel_detail' hotel.owner.id %}" style="text-decoration: none;"><h5 class="card-title">{{hotel.name|truncatechars:18}}</h5></a>
            <p class="card-text">{{ hotel.address|truncatechars:35 }}</p> 
            <p class="alert alert-secondary">Per Room Price: <b>NPR{{hotel.room_price}}</b></p>
        </div>
    </div>
</div> 
{% endfor %}

FYP_WICC/templates/hotels/update_hotel.html
{% extends 'base.html' %}

{% block title %}Update Hotel{% endblock %}

{% block content %}

<div class="row mt-3 mb-3">

    <div class="col-5 mx-auto">
        <p style="font-family: 'Brush Script MT', cursive; font-size:35px;" class="my-3">Update Hotel Details</p>
        <form method="post" novalidate> 

            {% if form.non_field_errors %}
                {% for err in form.non_field_errors %}
                    <p style="color:red;">{{ err }}</p>
                {% endfor %}
            {% endif %}

            {% csrf_token %}
            {% for field in form %}
               <p> {{ field.label_tag }} {{ field}} <span class="text-muted">{{field.help_text}}</span><span style="color:red;">{{ field.errors|striptags }}</span></p>
            {% endfor %}
            <input type="submit" value="Update" class="btn btn-success px-4">
            <a class="btn btn-secondary mx-2" href="{% url 'accounts:profile' %}">Cancel</a>
        </form>
    </div>

</div>

{% endblock %}